Attribute VB_Name = "AutoNew"
' Increment InvoiceNumber to New Form Document
Sub AutoNew()
 
  ' Create variables
  Dim fieldName As String
  Dim invNumber As String
  Dim iniFileName As String
  Dim templatePath As String
 
  fieldName = "InvoiceNumber"
  iniFileName = "Rechnungen.ini"
  templatePath = ActiveDocument.AttachedTemplate.Path
 
  On Error GoTo ErrHandler
 
  ' If the document does not contain a form field, exit this routine.
  ' The simplest is to look for its bookmark (its fieldname).
  If ActiveDocument.Bookmarks.Exists(fieldName) = False Then
    MsgBox "Die Textmarke " & fieldName & " wurde nicht gefunden!" & _
    vbCrLf & "Das automatische Eintragen einer Rechnungsnummer durch" & _
    vbCrLf & "das AutoNew-Makro ist aus diesem Grund nicht mglich.", _
    vbCritical, ActiveDocument.AttachedTemplate.Name
    End
  End If
 
  ' Read value from INI-file
  invNumber = System.PrivateProfileString(templatePath & _
    "\" & iniFileName, fieldName, "invNumber")
 
  ' Increment invoice number
  If invNumber = "" Then
    invNumber = 1
  Else
    invNumber = invNumber + 1
  End If
  ' Update InvoiceNumber in active document
  Dim ff As FormField
  For Each ff In ActiveDocument.FormFields
    If ff.Name = fieldName Then
      ff.Result = invNumber
    End If
  Next
 
  ' (Over)Write new value to INI-File
  System.PrivateProfileString(templatePath & "\" & _
    iniFileName, "InvoiceNumber", "invNumber") = invNumber
 
ErrHandler:
  If Err <> 0 Then
    MsgBox Err.Description
  End If
 
End Sub

